import annotation.switch

object WeekDay extends Enumeration {
  type WeekDay = Value
  val Mon, Tue, Wed, Thu, Fri, Sat, Sun = Value
  val Mon_ID = Mon.id;
  val Tue_ID = Tue.id;
  val Wed_ID = Wed.id;
  val Thu_ID = Thu.id;
  val Fri_ID = Fri.id;
  val Sat_ID = Sat.id;
  val Sun_ID = Sun.id;
}

import WeekDay._

class Test {
  


  def unannotated(x : Int) = x match {
    case 1 => "Raz"
    case 2 => "Dwa!"
    case z => z + "?"
  }
  def annotated(x : Int) = (x : @switch) match {
    case 1 => "Raz"
    case 2 => "Dwa!"
    case z => z + "?"
  }
  def notOptimized(x : Any) = x match {
    case 1 => "Raz"
    case 2 => "Dwa!"
    case _ => x + "?"
  }
  def notOptimised2(x : Int) = x match {
    case 1 => "Raz"
    case 2 => "Dwa!"    
    case i if i % 2 == 0 => "Parzysty"
    case _ => "Nieparzysty"
  }
  def notOptimised3(x : Int) = x match {
    case 1 => "Eaz"
    case 2 => "Dwa!"    
    case i : Int => "Inny"
  }
  def notOptimisedEnum(x : WeekDay) = x.id match {
    case Mon_ID => "Nie cierpię poniedziałku!"
    case Tue_ID => "Ruby Tuesday?"
    case Fri_ID => "Bogu dzięki!"
    case _ => "Ten dzień mnie nie interesuje"
  }

  def mightBeOptimised(x : WeekDay) = x match {
    case Mon => "Nie cierpię poniedziałku!"
    case Tue => "Ruby Tuesday?"
    case Fri => "Bogu dzięki!"
    case _ => "Ten dzień mnie nie interesuje"
  }
}
